Index: distrib/sets/lists/modules/mi
===================================================================
RCS file: /cvsroot/src/distrib/sets/lists/modules/mi,v
retrieving revision 1.51
diff -u -r1.51 mi
--- distrib/sets/lists/modules/mi	11 Mar 2013 15:53:05 -0000	1.51
+++ distrib/sets/lists/modules/mi	24 Jun 2013 19:14:19 -0000
@@ -179,6 +179,8 @@
 ./@MODULEDIR@/suser/suser.kmod			base-kernel-modules	kmod
 ./@MODULEDIR@/swsensor				base-kernel-modules	kmod
 ./@MODULEDIR@/swsensor/swsensor.kmod		base-kernel-modules	kmod
+./@MODULEDIR@/systrace				base-kernel-modules	kmod,dtrace
+./@MODULEDIR@/systrace/systrace.kmod		base-kernel-modules	kmod,dtrace
 ./@MODULEDIR@/sysvbfs				base-kernel-modules	kmod
 ./@MODULEDIR@/sysvbfs/sysvbfs.kmod		base-kernel-modules	kmod
 ./@MODULEDIR@/tmpfs				base-kernel-modules	kmod
Index: etc/etc.amd64/Makefile.inc
===================================================================
RCS file: /cvsroot/src/etc/etc.amd64/Makefile.inc,v
retrieving revision 1.14
diff -u -r1.14 Makefile.inc
--- etc/etc.amd64/Makefile.inc	4 Jul 2012 13:54:20 -0000	1.14
+++ etc/etc.amd64/Makefile.inc	24 Jun 2013 19:14:19 -0000
@@ -8,6 +8,7 @@
 
 KERNEL_SETS=		GENERIC
 KERNEL_SETS+=		XEN3_DOM0 XEN3_DOMU
+KERNEL_SETS+=		DTRACE
 # KERNEL_SETS+=		GENERIC_USERMODE
 
 BUILD_KERNELS=		INSTALL INSTALL_XEN3_DOMU
Index: external/cddl/osnet/dev/systrace/systrace.c
===================================================================
RCS file: /cvsroot/src/external/cddl/osnet/dev/systrace/systrace.c,v
retrieving revision 1.3
diff -u -r1.3 systrace.c
--- external/cddl/osnet/dev/systrace/systrace.c	17 Jul 2011 20:54:33 -0000	1.3
+++ external/cddl/osnet/dev/systrace/systrace.c	24 Jun 2013 19:14:20 -0000
@@ -38,7 +38,9 @@
 #include <sys/cpuvar.h>
 #include <sys/fcntl.h>
 #include <sys/filio.h>
+#ifdef __FreeBSD__
 #include <sys/kdb.h>
+#endif
 #include <sys/kernel.h>
 #include <sys/kmem.h>
 #include <sys/kthread.h>
@@ -51,9 +53,12 @@
 #include <sys/poll.h>
 #include <sys/proc.h>
 #include <sys/selinfo.h>
+#ifdef __FreeBSD__
 #include <sys/smp.h>
 #include <sys/sysproto.h>
 #include <sys/sysent.h>
+#endif
+#include <sys/syscallargs.h>
 #include <sys/uio.h>
 #include <sys/unistd.h>
 
@@ -78,7 +83,7 @@
  */
 #include <sys/syscall.h>
 #include <kern/systrace_args.c>
-extern const char	*syscallnames[];
+extern const char	* const syscallnames[];
 #define	DEVNAME		"dtrace/systrace"
 #define	PROVNAME	"syscall"
 #define	MAXSYSCALL	SYS_MAXSYSCALL
@@ -98,15 +103,18 @@
 #error 1 << SYSTRACE_SHIFT must exceed number of system calls
 #endif
 
+#ifdef __FreeBSD__
 static d_open_t	systrace_open;
+#endif
 static int	systrace_unload(void);
 static void	systrace_getargdesc(void *, dtrace_id_t, void *, dtrace_argdesc_t *);
-static void	systrace_provide(void *, dtrace_probedesc_t *);
+static void	systrace_provide(void *, const dtrace_probedesc_t *);
 static void	systrace_destroy(void *, dtrace_id_t, void *);
-static void	systrace_enable(void *, dtrace_id_t, void *);
+static int	systrace_enable(void *, dtrace_id_t, void *);
 static void	systrace_disable(void *, dtrace_id_t, void *);
 static void	systrace_load(void *);
 
+#ifdef __FreeBSD__
 static struct cdevsw systrace_cdevsw = {
 	.d_version	= D_VERSION,
 	.d_open		= systrace_open,
@@ -116,9 +124,10 @@
 	.d_name		= "systrace",
 #endif
 };
+#endif
 
 static union	{
-	const char	**p_constnames;
+	const char	* const *p_constnames;
 	char		**pp_syscallnames;
 } uglyhack = { SYSCALLNAMES };
 
@@ -143,7 +152,9 @@
 	systrace_destroy
 };
 
+#ifdef __FreeBSD__
 static struct cdev		*systrace_cdev;
+#endif
 static dtrace_provider_id_t	systrace_id;
 
 #if !defined(LINUX_SYSTRACE)
@@ -155,21 +166,21 @@
  *       compat syscall from something like Linux.
  */
 static void
-systrace_probe(u_int32_t id, int sysnum, struct sysent *sysent, void *params)
+systrace_probe(u_int32_t id, int sysnum, struct sysent *se, void *params)
 {
 	int		n_args	= 0;
-	u_int64_t	uargs[8];
+	union systrace_probe_args_un	uargs[SYS_MAXSYSARGS];
 
 	/*
 	 * Check if this syscall has an argument conversion function
 	 * registered.
 	 */
-	if (sysent->sy_systrace_args_func != NULL)
+	if (se->sy_systrace_args_func != NULL)
 		/*
 		 * Convert the syscall parameters using the registered
 		 * function.
 		 */
-		(*sysent->sy_systrace_args_func)(sysnum, params, uargs, &n_args);
+		(*se->sy_systrace_args_func)(sysnum, params, uargs, &n_args);
 	else
 		/*
 		 * Use the built-in system call argument conversion
@@ -180,7 +191,8 @@
 		systrace_args(sysnum, params, uargs, &n_args);
 
 	/* Process the probe using the converted argments. */
-	dtrace_probe(id, uargs[0], uargs[1], uargs[2], uargs[3], uargs[4]);
+	dtrace_probe(id, uargs[0].u, uargs[1].u, uargs[2].u, uargs[3].u,
+		uargs[4].u);
 }
 #endif
 
@@ -199,7 +211,7 @@
 }
 
 static void
-systrace_provide(void *arg, dtrace_probedesc_t *desc)
+systrace_provide(void *arg, const dtrace_probedesc_t *desc)
 {
 	int i;
 
@@ -238,7 +250,7 @@
 #endif
 }
 
-static void
+static int
 systrace_enable(void *arg, dtrace_id_t id, void *parg)
 {
 	int sysnum = SYSTRACE_SYSNUM((uintptr_t)parg);
@@ -250,6 +262,7 @@
 		SYSENT[sysnum].sy_entry = id;
 	else
 		SYSENT[sysnum].sy_return = id;
+	return 0;
 }
 
 static void
@@ -264,16 +277,18 @@
 static void
 systrace_load(void *dummy)
 {
+#ifdef __FreeBSD__
 	/* Create the /dev/dtrace/systrace entry. */
 	systrace_cdev = make_dev(&systrace_cdevsw, 0, UID_ROOT, GID_WHEEL, 0600,
 	   DEVNAME);
+#endif
 
 	if (dtrace_register(PROVNAME, &systrace_attr, DTRACE_PRIV_USER,
 	    NULL, &systrace_pops, NULL, &systrace_id) != 0)
 		return;
 
 #if !defined(LINUX_SYSTRACE)
-	systrace_probe_func = systrace_probe;
+	systrace_probe_func = (systrace_probe_func_t)systrace_probe;
 #endif
 }
 
@@ -290,11 +305,14 @@
 	systrace_probe_func = NULL;
 #endif
 
+#ifdef __FreeBSD__
 	destroy_dev(systrace_cdev);
+#endif
 
 	return (error);
 }
 
+#ifdef __FreeBSD__
 static int
 systrace_modevent(module_t mod __unused, int type, void *data __unused)
 {
@@ -340,3 +358,27 @@
 MODULE_DEPEND(systrace, dtrace, 1, 1, 1);
 MODULE_DEPEND(systrace, opensolaris, 1, 1, 1);
 #endif
+#endif /* __FreeBSD__ */
+
+#ifdef __NetBSD__
+
+static int
+systrace_modcmd(modcmd_t cmd, void *data)
+{
+	switch (cmd) {
+	case MODULE_CMD_INIT:
+		systrace_load(NULL);
+		return 0;
+
+	case MODULE_CMD_FINI:
+		systrace_unload();
+		return 0;
+
+	default:
+		return ENOTTY;
+	}
+}
+
+MODULE(MODULE_CLASS_MISC, systrace, "dtrace");
+
+#endif
Index: external/cddl/osnet/usr.sbin/dtrace/Makefile
===================================================================
RCS file: /cvsroot/src/external/cddl/osnet/usr.sbin/dtrace/Makefile,v
retrieving revision 1.4
diff -u -r1.4 Makefile
--- external/cddl/osnet/usr.sbin/dtrace/Makefile	22 Feb 2010 12:21:27 -0000	1.4
+++ external/cddl/osnet/usr.sbin/dtrace/Makefile	24 Jun 2013 19:14:20 -0000
@@ -6,6 +6,7 @@
 .include	"../../Makefile.inc"
 
 PROG=		dtrace
+MAN=		dtrace.1
 
 BINDIR?=	/usr/sbin
 
@@ -39,4 +40,5 @@
 
 LDADD+=		-ly -ll -lelf -lz
 
+
 .include <bsd.prog.mk>
Index: sys/arch/amd64/amd64/netbsd32_syscall.c
===================================================================
RCS file: /cvsroot/src/sys/arch/amd64/amd64/netbsd32_syscall.c,v
retrieving revision 1.31
diff -u -r1.31 netbsd32_syscall.c
--- sys/arch/amd64/amd64/netbsd32_syscall.c	20 Dec 2010 00:25:24 -0000	1.31
+++ sys/arch/amd64/amd64/netbsd32_syscall.c	24 Jun 2013 19:14:24 -0000
@@ -29,6 +29,8 @@
  * POSSIBILITY OF SUCH DAMAGE.
  */
 
+#include "opt_dtrace.h"
+
 #include <sys/cdefs.h>
 __KERNEL_RCSID(0, "$NetBSD: netbsd32_syscall.c,v 1.31 2010/12/20 00:25:24 matt Exp $");
 
@@ -80,6 +82,18 @@
 	SYSCALL_COUNT(syscall_counts, code);
 	SYSCALL_TIME_SYS_ENTRY(l, syscall_times, code);
 
+#ifdef KDTRACE_HOOKS
+	/*
+	 * If the systrace module has registered its probe
+	 * callback and if there is a probe active for the
+	 * syscall 'entry', process the probe.
+	 */
+	if (__predict_false(systrace_probe_func != NULL &&
+	    callp->sy_entry != 0))
+		(*systrace_probe_func)(callp->sy_entry, code, callp,
+		    args);
+#endif
+
 	params = (char *)frame->tf_rsp + sizeof(int);
 
 	if (callp->sy_argsize) {
@@ -105,6 +119,18 @@
 	error = sy_call(callp, l, args, rval);
 
 out:
+#ifdef KDTRACE_HOOKS
+	/*
+	 * If the systrace module has registered its probe
+	 * callback and if there is a probe active for the
+	 * syscall 'return', process the probe.
+	 */
+	if (__predict_false(systrace_probe_func != NULL &&
+	    callp->sy_return != 0))
+		(*systrace_probe_func)(callp->sy_return, code, callp,
+		    args);
+#endif
+
 	if (__predict_false(p->p_trace_enabled)
 	    && !__predict_false(callp->sy_flags & SYCALL_INDIRECT)) {
 		/* Recover 'code' - the compiler doesn't assign it a register */
Index: sys/arch/amd64/amd64/trap.c
===================================================================
RCS file: /cvsroot/src/sys/arch/amd64/amd64/trap.c,v
retrieving revision 1.75
diff -u -r1.75 trap.c
--- sys/arch/amd64/amd64/trap.c	14 Jan 2013 00:06:11 -0000	1.75
+++ sys/arch/amd64/amd64/trap.c	24 Jun 2013 19:14:24 -0000
@@ -117,6 +117,13 @@
 dtrace_trap_func_t	dtrace_trap_func = NULL;
 
 dtrace_doubletrap_func_t	dtrace_doubletrap_func = NULL;
+
+/*
+ * This is a hook which is initialised by the systrace module
+ * when it is loaded. This keeps the DTrace syscall provider
+ * implementation opaque.
+ */
+systrace_probe_func_t	systrace_probe_func;
 #endif
 
 void trap(struct trapframe *);
Index: sys/arch/x86/x86/syscall.c
===================================================================
RCS file: /cvsroot/src/sys/arch/x86/x86/syscall.c,v
retrieving revision 1.11
diff -u -r1.11 syscall.c
--- sys/arch/x86/x86/syscall.c	10 Jul 2012 21:18:07 -0000	1.11
+++ sys/arch/x86/x86/syscall.c	24 Jun 2013 19:14:24 -0000
@@ -29,6 +29,8 @@
  * POSSIBILITY OF SUCH DAMAGE.
  */
 
+#include "opt_dtrace.h"
+
 #include <sys/cdefs.h>
 __KERNEL_RCSID(0, "$NetBSD: syscall.c,v 1.11 2012/07/10 21:18:07 dsl Exp $");
 
@@ -132,6 +134,18 @@
 	SYSCALL_COUNT(syscall_counts, code);
 	SYSCALL_TIME_SYS_ENTRY(l, syscall_times, code);
 
+#ifdef KDTRACE_HOOKS
+	/*
+	 * If the systrace module has registered its probe
+	 * callback and if there is a probe active for the
+	 * syscall 'entry', process the probe.
+	 */
+	if (__predict_false(systrace_probe_func != NULL &&
+	    callp->sy_entry != 0))
+		(*systrace_probe_func)(callp->sy_entry, code, callp,
+		    args);
+#endif
+
 #ifdef __x86_64__
 	/*
 	 * The first 6 syscall args are passed in rdi, rsi, rdx, r10, r8 and r9
@@ -161,6 +175,18 @@
 		error = sy_call(callp, l, args, rval);
 	}
 
+#ifdef KDTRACE_HOOKS
+	/*
+	 * If the systrace module has registered its probe
+	 * callback and if there is a probe active for the
+	 * syscall 'return', process the probe.
+	 */
+	if (__predict_false(systrace_probe_func != NULL &&
+	    callp->sy_return != 0))
+		(*systrace_probe_func)(callp->sy_return, code, callp,
+		    args);
+#endif
+
 	if (__predict_false(p->p_trace_enabled)
 	    && !__predict_false(callp->sy_flags & SYCALL_INDIRECT)) {
 		trace_exit(code, rval, error);
Index: sys/compat/linux/arch/amd64/linux_sysent.c
===================================================================
RCS file: /cvsroot/src/sys/compat/linux/arch/amd64/linux_sysent.c,v
retrieving revision 1.44
diff -u -r1.44 linux_sysent.c
--- sys/compat/linux/arch/amd64/linux_sysent.c	8 Apr 2013 20:58:22 -0000	1.44
+++ sys/compat/linux/arch/amd64/linux_sysent.c	24 Jun 2013 19:14:24 -0000
@@ -1,4 +1,4 @@
-/* $NetBSD: linux_sysent.c,v 1.44 2013/04/08 20:58:22 pooka Exp $ */
+/* $NetBSD$ */
 
 /*
  * System call switch table.
@@ -8,7 +8,7 @@
  */
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: linux_sysent.c,v 1.44 2013/04/08 20:58:22 pooka Exp $");
+__KERNEL_RCSID(0, "$NetBSD$");
 
 #if defined(_KERNEL_OPT)
 #include "opt_sysv.h"
